#include <stdio.h>	/* for getchar() and printf() */
#include <stdlib.h>	/* for atexit() */
#include <ctype.h>	/* for isprint() */
#include "term.h"	/* declarations of the functions tty_raw() and tty_reset() */

int main(void) {
	int c;

	if(tty_raw(0) != -1) {	/* if setting stdin (fd 0) to RAW mode succeeds ... */
		atexit(tty_reset);	/* register tty_reset() to be called at exit */
	}

	/* continue until q is pressed or we reach the end of input.
	 * note: ctrl-D does not generate EOF now since no keystrokes
	 * are translated by the terminal driver, we get everything raw.
	 */
	while((c = getchar()) != EOF && c != 'q') {
		if(isprint(c)) {	/* if it is a printable character... */

			/* \r\n instead of simple \n, since now the carriage return 
			 * (i.e. return to the beginning of the line) is not implied...
			 */
			printf("got char: %c\r\n", c);
		}
	}

	return 0;
}
